/* 
   - The Original Code is this file as it was released on Februari 6, 2004.
   -
   - The Initial Developer of the Original Code is HJ van Rantwijk.
   - Portions created by HJ van Rantwijk are Copyright (C) 2004-2005
   - HJ van Rantwijk.  All Rights Reserved.
   -
*/

var gScreenX, gScreenY, gHeight, gWidth, gPanel, gPanelName, gModified = false;
var gEnableState, gImageBlockerState, gNavigator, gTabbrowser, gDocument, gPermissionManager, gEscapeKeyPressed = false;
var gSecondLevelPrefs = false;
var gNotificationsPrefPanel = false;
var gPrefFrame, gModifiedFilters = false;
var gActivePrefCategory = null;

if (hPrefWindow == undefined) // Fixing breakage caused by mozilla bug 228904 (FIXED)
  var hPrefWindow = null;

function Startup(aDialog)
{
  gPermissionManager = window.arguments[0];
  gPermissionManager.selectWindowStyling(aDialog);
  gScreenX = gPermissionManager.screenX;
  gScreenY = gPermissionManager.screenY;
  gHeight = (gPermissionManager.innerHeight / 50 - 2);
  gWidth = gPermissionManager.innerWidth;
  gPanel = gPermissionManager.dialogType;

  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                .getService(Components.interfaces.nsIWindowMediator);
  try { // Catch "undefined xyz" JS errors
    gNavigator = windowManager.getMostRecentWindow("navigator:browser");
    gTabbrowser = gNavigator.getBrowser();
    gDocument = gTabbrowser.contentDocument;
  } catch(ex) {
    gPermissionManager.open();
    gNavigator = windowManager.getMostRecentWindow("navigator:browser");
    gTabbrowser = gNavigator.getBrowser();
    gDocument = gTabbrowser.contentDocument;
  }
  if (!hPrefWindow) // Fixing breakage caused by mozilla bug 228904 (FIXED)
    hPrefWindow = new nsPrefWindow('panelFrame');
    
  if (!hPrefWindow)
    throw "Permissions Manager Failed to Create its Pref Window";
  hPrefWindow.init();
  document.getElementById('mac_button_spring').hidden = !(/Mac/.test(navigator.platform));
  gPrefFrame = document.getElementById(hPrefWindow.contentFrame);
  gPrefFrame.setAttribute("tag", gPanel);
  switchPanel(gPanel);

  if (gPermissionManager.gUseStackedWindows) {
    document.documentElement.setAttribute("hidechrome", "true");
    window.outerWidth = gWidth;
    window.outerHeight = 0;
    slideOpen(0);
  }
  else {
    window.outerWidth = gPermissionManager.outerWidth;
    window.outerHeight = gPermissionManager.outerHeight;
    document.getElementById("main-box").collapsed = false;
    document.getElementById("dialogButtonBox").collapsed = false;
  }
}

function slideOpen(aStep) // Modified Phoenix code!
{
  if (aStep < gHeight) {
    window.outerHeight += 50;
    setTimeout(slideOpen, 20, ++aStep);
  } else {
    window.outerHeight = gPermissionManager.innerHeight;
    document.getElementById("main-box").collapsed = false;
    document.getElementById("dialogButtonBox").collapsed = false;
  }
}

function slideClosed(aStep) // Modified Phoenix code!
{
  document.getElementById("dialogButtonBox").collapsed = true;

  if (gPermissionManager.gUseStackedWindows && aStep < gHeight) {
    window.outerHeight -= 50;
    setTimeout(slideClosed, 10, ++aStep);
  } else {
    window.close();
  }
}

function initPanel(aPanel)
{
  gPermissionManager.selectWindowStyling(aPanel);
  initPanelName();
  var headertitle = window.frames[hPrefWindow.contentFrame].document.getElementsByAttribute("headertitle", "*");
  var titleID = "";
  var panelTitle = gPanelName;

  if (gPanel == "cookie") {
    titleID = "mozillaCookiesSettingsPanelTitle";
    panelTitle = gPermissionManager.permissionsBundle.formatStringFromName(titleID, [gPanelName], 1);
  }
  else if (gPanel == "mozilla-image-prefs") {
    titleID = "mozillaImagesSettingsPanelTitle";
    panelTitle = gPermissionManager.permissionsBundle.formatStringFromName(titleID, [gPanelName], 1);
  }
  else if (gPanel == "popup") {
    titleID = "mozillaPopupsSettingsPanelTitle";
    panelTitle = gPermissionManager.permissionsBundle.formatStringFromName(titleID, [gPanelName], 1);
  }
  else if (gPanel == "mozilla-script-prefs") {
    titleID = "capsSettingsPanelTitle";
    panelTitle = gPermissionManager.permissionsBundle.formatStringFromName(titleID, [gPanelName], 1);
  }
  else if (gNotificationsPrefPanel) {
    titleID = "notificationsSettingsPanelTitle";
    panelTitle = gPermissionManager.permissionsBundle.formatStringFromName(titleID, [gPanelName], 1);
  }
  headertitle[0].setAttribute("headertitle", panelTitle);

  if (hPrefWindow)
    hPrefWindow.onpageload(gPanel);
  else
    queuedTag = gPanel;
}

function initPanelName()
{
  for (i in gPermissionManager.permissionTypes) {
    if (gPanel.match(gPermissionManager.permissionTypes[i]))
      break;
  }
  gPanelName = gPermissionManager.prefPanelNames[i]; // Set localized panel name
}

function switchPanel(aPanel, aSkipTestFlag)
{
  if (aSkipTestFlag == undefined && gActivePrefCategory == aPanel)
    return;

  gPanel = aPanel; // gPanel = current panel / aPanel = new panel
  var categoryButton = gPanel;
  var currentPanel = gPanel;
  var panelFile, panelPath = "chrome://multiviews/content/permission-manager/preferences/";

  switch(gPanel) {
    case "cookie": 
         panelFile = "permissionManagerCookiePanel.xul";
         gSecondLevelPrefs = false;
         gNotificationsPrefPanel = false;
         break;
    case "mozilla-image-prefs":
         // "content blocker image pref panel" : "mozilla image pref panel"
         panelFile = gSecondLevelPrefs ? "permissionManagerMainPanel.xul" : "permissionManagerImagePanel.xul";
         gSecondLevelPrefs = !gSecondLevelPrefs;
         gNotificationsPrefPanel = false;
         currentPanel = "image";
         categoryButton = currentPanel;

         if (!gSecondLevelPrefs)
           gPanel = categoryButton;
         break;
    case "popup": 
         panelFile = "permissionManagerPopupPanel.xul";
         gSecondLevelPrefs = false;
         gNotificationsPrefPanel = false;
         gPanel = categoryButton;
         break;
    case "install": 
         panelFile = "permissionManagerXPInstallPanel.xul";
         gSecondLevelPrefs = false;
         gNotificationsPrefPanel = false;
         gPanel = categoryButton;
         break;
    case "mozilla-script-prefs":
         // "content blocker script pref panel" : "CAPS settings for JavaScript"
         panelFile = gSecondLevelPrefs ? "permissionManagerMainPanel.xul" : "permissionManagerCAPSPanel.xul";
         gSecondLevelPrefs = !gSecondLevelPrefs;
         gNotificationsPrefPanel = false;
         currentPanel = "script";
         categoryButton = currentPanel;

         if (!gSecondLevelPrefs)
           gPanel = categoryButton;
         break;
    case "image-sound-prefs":
    case "popup-sound-prefs": /* for future use only */
    case "object-sound-prefs":
    case "script-sound-prefs":
    case "frame-sound-prefs":
    case "document-sound-prefs":
    case "meta-sound-prefs": /* for future use only */
         panelFile = gSecondLevelPrefs ? "permissionManagerMainPanel.xul" : "permissionManagerSoundPanel.xul";
         gSecondLevelPrefs = !gSecondLevelPrefs;
         gNotificationsPrefPanel = !gNotificationsPrefPanel;
         currentPanel = aPanel.replace(/-sound-prefs/, '');
         categoryButton = currentPanel;
         
         if (!gSecondLevelPrefs) { // Back button pressed?
           gPanel = categoryButton; // set gPanel to 'image'
         }
         break;

    default:
         // is our notifications pref panel displayed?
         if (gNotificationsPrefPanel) {
           // Yes, so we need to set panelFile and initialize some important vars
           panelFile = "permissionManagerSoundPanel.xul";
           // aPanel will be something like 'image' or any of the other categories
           currentPanel = aPanel;
           categoryButton = currentPanel;           
           aPanel = aPanel + "-sound-prefs";
           gPanel = aPanel;
         }
         else {
           panelFile = "permissionManagerMainPanel.xul";
           gSecondLevelPrefs = false;
           gNotificationsPrefPanel = false;
         }
  }
  gPermissionManager.switchTree(currentPanel); // select the permissions category panel
  gActivePrefCategory = currentPanel; // keep the selected pref category
  var panelURL = panelPath + panelFile;
  var contentFrame = document.getElementById(hPrefWindow.contentFrame);
  sortFiltersInTextbox();
  // Save pref panel settings
  var currentPanelTag = contentFrame.getAttribute("tag");
  hPrefWindow.wsm.savePageData(currentPanelTag, null);
  contentFrame.setAttribute("tag", aPanel);
  // Reload/reinitialize pref panel
  contentFrame.removeAttribute("src");
  contentFrame.setAttribute("src", panelURL);
  // Display 'Back' button for secondary level pref panels
  document.getElementById('backButton').hidden = !gSecondLevelPrefs;
  // Hide 'Cancel' button for secondary pref panels
  document.documentElement.getButton('cancel').hidden = gSecondLevelPrefs;
  // Update label and default attribute for modified pref panels
  if (gModified)
    hasModifiedPrefs();
  else
    selectDefaultButton();
  // Select new category button
  categoryButton = document.getElementById(categoryButton);
  categoryButton.checked = true;
  categoryButton.focus();
}

function selectSecondaryPrefPanel()
{
  switch (gPanel) 
  {
    case "image": // "image" or "mozilla-image-prefs"
      switchPanel("mozilla-image-prefs");
      break;
    case "script": // "script" or "mozilla-script-prefs"
      switchPanel("mozilla-script-prefs");
      break;
    /* case "image-sound-prefs":
    case "popup-sound-prefs":
    case "object-sound-prefs":
    case "script-sound-prefs":
    case "frame-sound-prefs":
    case "document-sound-prefs":
    case "meta-sound-prefs":
      switchPanel(gPanel);
      break; */
  }
}

function sortFiltersInTextbox(aPageTag)
{
  var selectedTag = (aPageTag == undefined) ? null : aPageTag.replace(/pref-regex-/i, '');

  if (gModifiedFilters) { // Automatic sort of modified filters!
    var patterns = new Array();
  
    for (var pageTag in hPrefWindow.wsm.dataManager.pageData) {
      // Check for pageTag for wrong or Cookies and Popups pref panels
      if (pageTag == "cookies" || pageTag == "popups" || (aPageTag && selectedTag != pageTag)) {
        continue; // Skip this one. No filter pattern or wrong pageTag
      }
      else {
        var pageData = hPrefWindow.wsm.dataManager.getPageData(pageTag);

        for (var elementID in pageData) {
          // dump("\nelementID: " + elementID);
		  if (elementID == "pref-regex-" + pageTag) {
            var textbox = hPrefWindow.wsm.contentArea.document.getElementById(elementID);

            if (!textbox) {
              // dump("\nFailed for elementID: " + elementID);
              continue;
            }
            patterns = textbox.value;

            if (patterns.length) {
              patterns = patterns.replace(/\s/g, '').replace(/\.\./g, '.').split(',');
              patterns = patterns.sort();
              var filterString = "";
              // Reconstruct pattern for textbox
              for (var p = 0; p < patterns.length; p++) {
                if (patterns[p].length) { // prevent adding useless/spurious ", "
                  patterns[p] = patterns[p].replace(/\,/, '');
                  filterString += patterns[p] + ", "; // The extra space is to make wrap work!
                }
              }
              filterString = filterString.replace(/, $/, ''); // Remove trailing space and comma
              textbox.value = filterString; // Update textbox
            }
          }
        }
      }
    }
    gModifiedFilters = false;
  }
}

function preExitCall(aEvent, aFlag)
{
  if (gModified) {
    if (aFlag || gEscapeKeyPressed) {
      hasModifiedPrefs('no');

      if (gPermissionManager.getConfirmation(window, 'cbWizard', 'cbConfirmCloseText')) {
        // Re-sort modified filters
        sortFiltersInTextbox();

        if ("onOK" in hPrefWindow) // Fixing breakage caused by mozilla bug 228904 (FIXED)
          hPrefWindow.onOK(aEvent);
        else
          hPrefWindow.onAccept(aEvent);
      }
    }
    else {
      // Re-sort modified filters
      sortFiltersInTextbox();
    }
  }
  var activatePreviousPanel = (!gModified && gEscapeKeyPressed && (gSecondLevelPrefs || gNotificationsPrefPanel));

  if (activatePreviousPanel) {
    switchPanel(gPanel);
  }
  else {
    document.getElementById("main-box").collapsed = true;

    switch (gPanel) 
    {
      case "cookie":
        if (gPermissionManager.gDisplayCookieData && gPermissionManager.gCookieDataFromPrefPanel) {
          gPermissionManager.gDisplayCookieData = false;
          gPermissionManager.gCookieDataFromPrefPanel = false;
        }
        break;
      case "mozilla-image-prefs":
        gPanel = "image";
        break;

      case "mozilla-script-prefs":
        gPanel = "script";
        break;

      default: 
        gPanel = gPanel.replace(/-sound-prefs/, '');
    }
    gPermissionManager.switchTree(gPanel, true);
    slideClosed(0);
  }
}

function onAccept(aEvent)
{
  preExitCall(aEvent, false);

  if ("onOK" in hPrefWindow) // Fixing breakage caused by mozilla bug 228904 (FIXED)
    hPrefWindow.onOK(aEvent);
  else 
    hPrefWindow.onAccept(aEvent);
  // We might need to refresh the 'Open Tab' and 'Ask Me' buttons!
  if (gPanel == 'popup')
    gPermissionManager.updateToolbarButtons();

  gPermissionManager.displayTreeMessage(gPanel);
}

function onCancel(aEvent, aFlag)
{
  preExitCall(aEvent, aFlag);

  if (!gEscapeKeyPressed) {
    hPrefWindow.onCancel(aEvent);
  }
}

function hasModifiedPrefs(aState)
{
  var acceptButton = document.documentElement.getButton('accept');
  gModified = (aState == "no") ? false : true;
  acceptButton.disabled = !gModified;

  if (!gSecondLevelPrefs) {
    var cancelButton = document.documentElement.getButton('cancel');
    cancelButton.label = gPermissionManager.permissionsBundle.GetStringFromName('pmCancelButton.label');
  }
  selectDefaultButton();
}

function selectDefaultButton()
{
  var defaultButton;
  var backButton = document.getElementById('backButton');
  var acceptButton = document.documentElement.getButton('accept');
  var cancelButton = document.documentElement.getButton('cancel');

  backButton.removeAttribute('default');
  acceptButton.removeAttribute('default');
  cancelButton.removeAttribute('default');

  if (gSecondLevelPrefs)
    defaultButton = backButton;
  else
    defaultButton = cancelButton;

  if (gModified)
    defaultButton = acceptButton;
  defaultButton.setAttribute('default', 'true');
  // defaultButton.focus();
}

function mzSpinButton(aDocument, aElementId, aStepValue, aMinValue, aMaxValue)
{
  /***
    * The 'onup' and 'ondown' buttons/images are always functional, even 
    * when disabled, so we need to check this to prevent failures!
    */
  if (!aDocument || !aElementId)
    return;
  var spinbutton = aDocument.getElementById(aElementId);

  if (!spinbutton || spinbutton.disabled)
    return;

  var newValue = Number(spinbutton.value) + Number(aStepValue);
  spinbutton.value = (newValue > (aMinValue-1) && newValue < (aMaxValue+1)) ? newValue : (newValue < aMinValue) ? aMaxValue : aMinValue;
  hasModifiedPrefs();
}

function mzKeySpinButton(aEvent)
{
  /***
    * The 'onup' and 'ondown' buttons/images are always functional, even 
    * disable doesn't disable them, so we need to check this ourselfs!
    */
  if (!aEvent || (aEvent.keyCode != 38 && aEvent.keyCode != 40))
    return;

  aEvent.preventDefault();

  var newValue;
  var textBox = aEvent.target;
  var spinbuttonID = textBox.getAttribute('control');

  if (!spinbuttonID)
    return;

  var spinbutton = aEvent.target.ownerDocument.getElementById(spinbuttonID);

  if (!spinbutton || spinbutton.disabled)
    return;

  var minValue = Number(spinbutton.getAttribute('min'));
  var maxValue = Number(spinbutton.getAttribute('max'));
  var stepValue = Number(spinbutton.getAttribute('step'));
  stepValue = stepValue ? stepValue : 5;

  if (aEvent.keyCode == 40)
    newValue = Number(aEvent.target.value) - stepValue;
  else if (aEvent.keyCode == 38)
    newValue = Number(aEvent.target.value) + stepValue;
  // dump("\nminValue: " + minValue + "maxValue: " + maxValue + "stepValue: " + stepValue);
   aEvent.target.value = (newValue > (minValue-1) && newValue < (maxValue+1)) ? newValue : (newValue < minValue) ? maxValue : minValue;
  hasModifiedPrefs(true);
  textBox.focus();
}

function mzValidateSpinValue(aEvent)
{
  if (!aEvent)
    return;

  var textBox = aEvent.target;
  var spinbuttonID = textBox.getAttribute('control');

  if (!spinbuttonID)
    return;

  var spinbutton = aEvent.target.ownerDocument.getElementById(spinbuttonID);

  if (!spinbutton || spinbutton.disabled)
    return;

  if (aEvent.keyCode != 38 && aEvent.keyCode != 40) {
    var currentValue = Number(aEvent.target.value);
    var minValue = Number(spinbutton.getAttribute('min'));
    var maxValue = Number(spinbutton.getAttribute('max'));
    var stepValue = Number(spinbutton.getAttribute('step'));
    stepValue = stepValue ? stepValue : 5;

    if (currentValue < minValue || currentValue > maxValue)
      aEvent.target.value = minValue;
  }
  hasModifiedPrefs(true);
  textBox.focus();
}
